﻿Imports System.Collections.ObjectModel
Imports C1.Chart
Imports C1.Win.Chart
Imports C1.Win.FlexReport
Imports C1.Win.FlexReport.Chart

Public Class Form1
    Dim source As ObservableCollection(Of Product)
    Sub New()

        InitializeComponent()
        source = New ObservableCollection(Of Product)
        Dim product1 = New Product()
        product1.Name = "Product 1"
        product1.Amount = 2
        source.Add(product1)

        Dim product2 = New Product()
        product2.Name = "Product 2"
        product2.Amount = 2
        source.Add(product2)

        Dim product3 = New Product()
        product3.Name = "Product 3"
        product3.Amount = 0
        source.Add(product3)

        Dim report = New C1FlexReport()
        report.Load("../../FlexChartDemo.flxr", "Chart1")

        report.DataSource.Recordset = source
        Dim chart = CreateChartField("Chart1")
        chart.Top = 10
        chart.Left = 400
        chart.Height = 3500
        chart.Width = 4800
        chart.ChartArea2D.AxisY.AutoMajor = False
        chart.ChartArea2D.AxisY.UnitMajor = 1
        chart.ChartArea2D.AxisX.AnnoRotation = 50
        chart.ChartArea2D.AxisX.Font.Bold = True
        chart.ChartArea2D.AxisY.AutoMin = False
        chart.ChartArea2D.AxisY.Min = 1


        Dim group = chart.ChartGroups2D.Group0
        group.ChartType = C1.Win.FlexReport.Chart.Chart2DType.Bar 'Chart2DType.Bar
        Dim data = group.ChartData
        data.IsForEachRecord = True ' show value of each record in data source
        data.CategoryGroups.AddNewGroup("=Name") ' group by FullName
        data.ColorMode = ChartColorMode.ColorByCategory 'Für Unterschiedliche Fareben

        Dim seriesTemplate = data.SeriesValues.AddNewSeries()
        seriesTemplate.DataValues.AddNewValue("=Amount") ' show count in AxisY
        seriesTemplate.LegendEntry = True
        'Show the values
        seriesTemplate.DataLabel.Visible = True
        'seriesTemplate.DataLabel.Text = "{#YVAL}"
        'Values display location and fonts
        seriesTemplate.DataLabel.Compass = ChartLabelCompass.North 'i.e. On top of bar
        seriesTemplate.DataLabel.Style.Font.Bold = True



        report.Sections.Header.Fields.Add(chart)
        C1FlexViewer1.DocumentSource = report

    End Sub

    Private Function CreateChartField(v1 As String) As ChartField

        Dim ChartField = New ChartField()
        'Dim series = New C1.Win.FlexReport.FlexChart.Series()
        'series.YExpression = "Amount"
        'ChartField.Series.Add(series)
        ChartField.Name = v1
        'ChartField.ChartType = ChartType.Column
        'ChartField.XLabelExpression = "Name"
        Return ChartField
    End Function
End Class

Class Product
    Property Name As String
    Property Amount As Integer
End Class

